import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Cat here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cat extends Actor
{
    /**
     * Act - do whatever the Cat wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int speed = 7;
    private int vSpeed = 0;
    private int acceleration = 2;
    private int jumpStrength = 5;
    
    public void act() 
    {
        checkKeys();
        checkFall();
        
    }    
    
    public void checkFall() {
        if(onGround()) {
            vSpeed = 0;
        }
        else {
            fall();
        }
    }
    
    private void checkKeys() {
        if(Greenfoot.isKeyDown("left")) {
            setImage("cat.png");
            moveLeft();
        }
        
        if(Greenfoot.isKeyDown("right")) {
            setImage("cat.png");
            moveRight();
        }
        
        if(Greenfoot.isKeyDown("space")) {
            jump();
        }
    }
    
    public void jump() {
        vSpeed = -4;
        fall();
    }
    
    public int getHeight() {
        return getImage().getHeight();
    }
    
    public boolean onGround() {
        Actor under = getOneObjectAtOffset ( 0, getHeight() / 2, Ground.class);
        return under != null;
    }
    
    public void fall() {
        setLocation(getX(), getY() + vSpeed);
        vSpeed = vSpeed + acceleration;
    }
    
    public void moveRight() {
        setLocation(getX() + speed, getY() );
        setImage("cat-turn.png");
    }
    
    public void moveLeft() {
        setLocation(getX() - speed, getY() );
        setImage("cat.png");
    }
}
